// ==================== TMSF28335 SCIA   ==================
// Devices: TMS320F28335
// ----------------------------------------------------------------
#include "DSP2833x_main.h"   

// Լ 
void com_init(int port,unsigned long baud_rate,int parity,int data,int stop);// COM1 

void com1_putch(unsigned char data);				// 1Ʈ ۽
unsigned char com1_getch(void);					// 1Ʈ 
void com2_putch(unsigned char data);				// 1Ʈ ۽
unsigned char com2_getch(void);					// 1Ʈ 
void com3_putch(unsigned char data);				// 1Ʈ ۽
unsigned char com3_getch(void);					// 1Ʈ 

int Printf(char port,char *form, ... );				// COM printf func

//  

// ܺ  

// ======================== ø Ʈ1 ʱȭ ===================
// [μ] int port,unsigned long baud_rate,int pariy,int data,int stop  
// Item1:  Ʈ(_COM1,2,3)
// Item2:  Ʈ
// Item3:  ䷯Ƽ(NON_P,ODD_P,EVEN_P)
// Item4:  (1-8)
// Item5:  STOP Ʈ(1,2)
// ----------------------------------------------------------------
void com_init(int port,unsigned long baud_rate,int parity,int data,int stop)
{                  
unsigned datau = 0U;
unsigned long baud;

	asm(" EALLOW");						// Enable EALLOW protected register access
	switch(port){
	    case _COM1:
		GpioCtrlRegs.GPAQSEL2.bit.GPIO28 = 3;		// Asynch input GPIO28(SCIRXDA)
		GpioCtrlRegs.GPAMUX2.bit.GPIO28 = 1;		// 0=GPIO 1=SCIRXDA 2=XZCS6 3=XZCS6
		GpioCtrlRegs.GPAMUX2.bit.GPIO29 = 1;		// 0=GPIO 1=SCITXDA 2=XA19  3=XA19

//		GpioCtrlRegs.GPBQSEL1.bit.GPIO36 = 3;		// Asynch input GPIO28 (SCIRXDA)
//		GpioCtrlRegs.GPBMUX1.bit.GPIO35 = 1;		// 0=GPIO 1=SCITXDA 2=XR/W  3=XR/W
//		GpioCtrlRegs.GPBMUX1.bit.GPIO36 = 1;		// 0=GPIO 1=SCIRXDA 2=XZCS0 3=XZCS0
		break;
	    case _COM2:
//		GpioCtrlRegs.GPAQSEL1.bit.GPIO11 = 3;		// Asynch input GPIO11(SCIRXDB)
//		GpioCtrlRegs.GPAMUX1.bit.GPIO9  = 2;		// 0=GPIO 1=EPWM5B 2=SCITXDB 3=ECAP3
//		GpioCtrlRegs.GPAMUX1.bit.GPIO11 = 2;		// 0=GPIO 1=EPWM6B 2=SCIRXDB 3=ECAP4

		GpioCtrlRegs.GPAQSEL1.bit.GPIO15 = 3;		// Asynch input GPIO15 (SCIRXDB)
		GpioCtrlRegs.GPAMUX1.bit.GPIO14 = 2;		// 0=GPIO 1=TZ3/XHOLD  2=SCITXDB 3=SPICLKB
		GpioCtrlRegs.GPAMUX1.bit.GPIO15 = 2;		// 0=GPIO 1=TZ4/XHOLDA 2=SCIRXDB 3=SPISTEB

//		GpioCtrlRegs.GPAQSEL2.bit.GPIO19 = 3;		// Asynch input GPIO19 (SCIRXDB)
//		GpioCtrlRegs.GPAMUX2.bit.GPIO18 = 2;		// 0=GPIO 1=SPICLKA 2=SCITXDB 3=CANRXA
//		GpioCtrlRegs.GPAMUX2.bit.GPIO19 = 2;		// 0=GPIO 1=SPISTEA 2=SCIRXDB 3=CANTXA

//		GpioCtrlRegs.GPAQSEL2.bit.GPIO23 = 3;		// Asynch input GPIO23 (SCIRXDB)
//		GpioCtrlRegs.GPAMUX2.bit.GPIO22 = 3;		// 0=GPIO 1=EQEP1S 2=MCLKXA 3=SCITXDB
//		GpioCtrlRegs.GPAMUX2.bit.GPIO23 = 3;		// 0=GPIO 1=EQEP1I 2=MFSXA  3=SCIRXDB
		break;
	    case _COM3:
		GpioCtrlRegs.GPBQSEL2.bit.GPIO62 = 3;		// Asynch input GPIO62(SCIRXDC)
		GpioCtrlRegs.GPBMUX2.bit.GPIO62 = 1;		// 0=GPIO  1=SCIRXDC   2=XD17       3=XD17
		GpioCtrlRegs.GPBMUX2.bit.GPIO63 = 1;		// 0=GPIO  1=SCITXDC   2=XD16       3=XD16
		break;
	    default: break;
	}
	asm(" EDIS");						// Disable EALLOW protected register access
	datau = (data - 1) & 0x07;				// data bit setup
	if(parity == ODD_P) datau |= 0x20;			// parity setup 
	else if(parity == EVEN_P) datau |= 0x60; 
	if(stop == 2) datau |= 0x80; 				// STOP bit setup
	baud = (37500000UL / (baud_rate * 8UL)) - 1UL;		// baud rate set
	switch(port){
	    case _COM1:
		SciaRegs.SCICCR.all = datau;
		SciaRegs.SCICTL1.all =0x0003;			// enable TX, RX, RX_ERR internal SCICLK, 
		                             			// Disable SLEEP, TXWAKE
		SciaRegs.SCICTL2.all =0x0003;			// RX interrupt enable
		SciaRegs.SCICTL2.bit.TXINTENA = 1;
		SciaRegs.SCICTL2.bit.RXBKINTENA =1;
		SciaRegs.SCIHBAUD = (baud >> 8) & 0xff;
		SciaRegs.SCILBAUD = baud & 0xff;    
		SciaRegs.SCICTL1.all =0x0023;			// Relinquish SCI from Reset.SCIFFCT.all=0x0;

		SciaRegs.SCIFFTX.all=0xc020;
		SciaRegs.SCIFFRX.all=0x2021;
		SciaRegs.SCIFFCT.all=0x0;
		SciaRegs.SCIFFTX.bit.TXFIFOXRESET=1;
		SciaRegs.SCIFFRX.bit.RXFIFORESET=1;
		
		PieCtrlRegs.PIECTRL.bit.ENPIE = 1;		// Enable the PIE block
   		PieCtrlRegs.PIEIER9.bit.INTx1 = 1;		// Enable all SCIA RXINT interrupt
	   	IER |= 0x0100;	         			// Enable INT9 in IER to enable PIE group9
		
		break;
	    case _COM2:
		ScibRegs.SCICCR.all = datau;
		ScibRegs.SCICTL1.all =0x0003;			// enable TX, RX, RX_ERR internal SCICLK, 
		                             			// Disable SLEEP, TXWAKE
		ScibRegs.SCICTL2.all =0x0003;			// RX interrupt enable
		ScibRegs.SCICTL2.bit.TXINTENA = 1;
		ScibRegs.SCICTL2.bit.RXBKINTENA =1;
		ScibRegs.SCIHBAUD = (baud >> 8) & 0xff;
		ScibRegs.SCILBAUD = baud & 0xff;    
		ScibRegs.SCICTL1.all =0x0023;			// Relinquish SCI from Reset		

		ScibRegs.SCIFFTX.all=0xc020;
		ScibRegs.SCIFFRX.all=0x2021;
		ScibRegs.SCIFFCT.all=0x0;
		ScibRegs.SCIFFTX.bit.TXFIFOXRESET=1;
		ScibRegs.SCIFFRX.bit.RXFIFORESET=1;
		
		PieCtrlRegs.PIECTRL.bit.ENPIE = 1;		// Enable the PIE block
		PieCtrlRegs.PIEIER9.bit.INTx3 = 1;		// Enable all SCIB RXINT interrupt
		IER |= 0x0100;			   		// Enable INT9 in IER to enable PIE group9		
		break;
	    case _COM3:
		ScicRegs.SCICCR.all = datau;
		ScicRegs.SCICTL1.all =0x0003;			// enable TX, RX, RX_ERR internal SCICLK, 
		                             			// Disable SLEEP, TXWAKE
		ScicRegs.SCICTL2.all =0x0003;			// RX interrupt enable
		ScicRegs.SCICTL2.bit.TXINTENA = 1;
		ScicRegs.SCICTL2.bit.RXBKINTENA =1;
		ScicRegs.SCIHBAUD = (baud >> 8) & 0xff;
		ScicRegs.SCILBAUD = baud & 0xff;    
		ScicRegs.SCICTL1.all =0x0023;			// Relinquish SCI from Reset

		ScicRegs.SCIFFTX.all=0xc020;
		ScicRegs.SCIFFRX.all=0x2021;
		ScicRegs.SCIFFCT.all=0x0;
		ScicRegs.SCIFFTX.bit.TXFIFOXRESET=1;
		ScicRegs.SCIFFRX.bit.RXFIFORESET=1;

		PieCtrlRegs.PIECTRL.bit.ENPIE = 1;		// Enable the PIE block
		PieCtrlRegs.PIEIER8.bit.INTx5 = 1;		// Enable all SCIC RXINT interrupt
	   	IER |= 0x0080;	         			// Enable INT8 in IER to enable PIE group9
		break;
	    default:
	    	break;
	}
}

// ======================== ø Ʈ1 TX =======================
// [μ] unsigned char data
// Item1:  
// ----------------------------------------------------------------
void com1_putch(unsigned char data)
{            
	while(SciaRegs.SCIFFTX.bit.TXFFST != 0){}	// fifo ˻
	SciaRegs.SCITXBUF = data;
}

// ======================== ø Ʈ2 TX =======================
// [μ] unsigned char data
// Item1:  
// ----------------------------------------------------------------
void com2_putch(unsigned char data)
{            
	while(ScibRegs.SCIFFTX.bit.TXFFST != 0){}	// fifo ˻
	ScibRegs.SCITXBUF = data;
}

// ======================== ø Ʈ3 TX =======================
// [μ] unsigned char data
// Item1:  
// ----------------------------------------------------------------
void com3_putch(unsigned char data)
{            
	while(ScicRegs.SCIFFTX.bit.TXFFST != 0){}	// fifo ˻
	ScicRegs.SCITXBUF = data;
}
 
// ======================== ø Ʈ1 RX =======================
// [μ] void
// []  
// ----------------------------------------------------------------
unsigned char com1_getch(void)
{   
unsigned char ch;

	while(SciaRegs.SCIFFRX.bit.RXFFST == 0);	// wait for XRDY =1 for empty state
	ch = SciaRegs.SCIRXBUF.all;
	return(ch);
}

// ======================== ø Ʈ2 RX =======================
// [μ] void
// []  
// ----------------------------------------------------------------
unsigned char com2_getch(void)
{   
unsigned char ch;

	while(ScibRegs.SCIFFRX.bit.RXFFST == 0){ }	// wait for XRDY =1 for empty state
	ch = ScibRegs.SCIRXBUF.all;
	return(ch);
}

// ======================== ø Ʈ3 RX =======================
// [μ] void
// []  
// ----------------------------------------------------------------
unsigned char com3_getch(void)
{
unsigned char ch;

	while(ScicRegs.SCIFFRX.bit.RXFFST == 0){ }	// wait for XRDY =1 for empty state
	ch = ScicRegs.SCIRXBUF.all;
	return(ch);
}

// ================================ Printf() =======================
//  [μ] char port						     
//	   unsigned short form					     
//	   ...							     
//  Item1:  (_COM1,_COM2,_COM3,_COM4) 		     
//  Item2:  Format					     
//  Item3: μ 						     
//  [] (   ȯ),() 	     
// -----------------------------------------------------------------
int Printf(char port,char *form, ... )
{
char buff[100];
int i,j,len;
unsigned char Ch = 0;
va_list  argptr;						//  Ʈ 

	buff[0] = 0x0;
	buff[1] = 0x0;
	va_start( argptr, form );				// va_ Լ ʱȭ 
	len = vsprintf(buff, form, argptr );			// format Ĵ ۷ 
	va_end( argptr );					// va_ Լ 
//  
	if(len == -1) return(len);
// ǥ  Լ 
	for(i = 0,j = 0; i < len; i++){
		Ch = buff[i];
		if(port == _COM1) com1_putch(Ch);		// COM1 Tx 
		else if(port == _COM2) com2_putch(Ch);		// COM2 Tx
		else if(port == _COM3) com3_putch(Ch);		// COM3 Tx 
		j++;
	}
	return(j);						//   
}
