// ================================== F28335 α׷ ========================
//  CPU : TMS320F28335-150M
//     ¥ : 2009-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CCS3.3
// [ ]  : OSC 30M
// ----------------------------------------------------------------------------
#include "DSP2833x_main.h"   

// Լ 
void main_menu(void);						//  ޴ ǥ
void analog_test(void);						// analog test
void sram_test(void);						// sram   test
void digital_in_test(void);					// DIGITAL IN  test
void digital_out_test(void);					// DIGITAL OUT test

long atoh(char buff[]);    					// ASCII TO HEX
void rx_string(char buff[]);					// ڿ 

// ܺ  
extern unsigned char com1_recv_data[];				// COM1  ͷƮ  fifo
extern int com1_rx_usi,com1_rx_udi;

//  
unsigned int *EX_SRAM_ADDR = (unsigned int*)0x200000;		// SRAM ּ(ZCS7)
_iq coeffs[10] = {_IQ(0.0625),_IQ(0.25),_IQ(0.375),_IQ(0.25),_IQ(0.0625)};// filter coefficients

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
void main(void)
{
unsigned char ch;

	cpu_setup();						// H/W ʱȭ  
	main_menu();						//  ޴ ǥ
	while(1){
		if(com1_rx_usi != com1_rx_udi){			//  ˻
			ch = com1_recv_data[com1_rx_udi++];	// ring   ε
			if(com1_rx_udi >= 50) com1_rx_udi = 0;
			if(ch == '1'){				// DIGITAL-IN TEST
		    		digital_in_test();
		    		main_menu();
			}    
			else if(ch == '2'){			// DIGITAL-OUT TEST
		    		digital_out_test();
		    		main_menu();
			}    
			else if(ch == '3'){			// ANALOG TEST
		    		analog_test();
		    		main_menu();
			}    
			else if(ch == '4'){			// SRAM TEST
		    		sram_test();
		    		main_menu();
			}    
			else com1_putch(ch);			//  ۽
		}
	}	
}

// =========================  ޴ ǥ =======================
// μ] void
// ----------------------------------------------------------------
void main_menu(void)
{
	Printf(_COM1,"\r\n");
	Printf(_COM1,"%s","========== Main Menu 1.1 =========\r\n");
	Printf(_COM1,"%s","- 1 : Digital IN  TEST           -\r\n");
	Printf(_COM1,"%s","- 2 : Digital OUT TEST           -\r\n");
	Printf(_COM1,"%s","- 3 : ANALOG TEST                -\r\n");
	Printf(_COM1,"%s","- 4 : SRAM   TEST                -\r\n");
	Printf(_COM1,"%s","----------------------------------\r\n");
}

// ========================== DIGITAL IN TEST ======================
// [μ] void					    
// -----------------------------------------------------------------
void digital_in_test(void)
{
unsigned char com1_rx_data;	
int exit_flg = 0;
unsigned long datal;

	Printf(_COM1,"%s","============ DIGITAL INPUT ========\r\n");
	Printf(_COM1,"%s","- 1 : RETURN POP UP               -\r\n");
	Printf(_COM1,"%s","- 2 : GPA(GPIO0-15) INPUT         -\r\n");
	Printf(_COM1,"%s","-----------------------------------\r\n");
	com1_rx_usi = com1_rx_udi = 0;
	asm(" EALLOW");						// Enable EALLOW protected register access
	GpioCtrlRegs.GPAMUX1.all &= 0xffff0000;			// GPIO0-15 GPIO
	GpioCtrlRegs.GPADIR.all  &= 0xffff0000;			// GPIO0-15 input
 	asm(" EDIS");						// Disable EALLOW protected register access
 	while(exit_flg == 0){
		if(com1_rx_usi != com1_rx_udi){
			com1_rx_usi = com1_rx_udi = 0;
			com1_rx_data = com1_recv_data[com1_rx_udi];// ring   ε
			switch(com1_rx_data){
				case  '1' : exit_flg = 1; break;
				case  '2' :
					datal = ~GpioDataRegs.GPADAT.all & 0xffff;
					Printf(_COM1,"INP(GPIO0-15) : %08lx\r\n",datal);
					break;
				default   :
					break;
			}
	    }
	}
	com1_rx_usi = com1_rx_udi = 0;
}

// ========================== DIGITAL OUTPUT EST ===================
// [μ] void					    
// -----------------------------------------------------------------
void digital_out_test(void)
{
unsigned char com1_rx_data;	
int exit_flg = 0;

	Printf(_COM1,"%s","========= DIGITAL OUTPUT ==========\r\n");
	Printf(_COM1,"%s","- 1 : RETURN POP UP               -\r\n");
	Printf(_COM1,"%s","- 2 : GPA(GPIO0-15) output : 0000H -\r\n");
	Printf(_COM1,"%s","- 3 : GPA(GPIO0-15) output : aaaaH -\r\n");
	Printf(_COM1,"%s","- 4 : GPA(GPIO0-15) output : 5555H -\r\n");
	Printf(_COM1,"%s","- 5 : GPA(GPIO0-15) output : ffffH -\r\n");
	Printf(_COM1,"%s","-----------------------------------\r\n");
	com1_rx_usi = com1_rx_udi = 0;
	asm(" EALLOW");						// Enable EALLOW protected register access
	GpioCtrlRegs.GPAMUX1.all &= 0xffff0000;			// GPIO0-15 GPIO
	GpioCtrlRegs.GPADIR.all  |= 0x0000ffff;			// GPIO0-15 output
 	asm(" EDIS");						// Disable EALLOW protected register access
 	while(exit_flg == 0){
		if(com1_rx_usi != com1_rx_udi){
			com1_rx_usi = com1_rx_udi = 0;
			com1_rx_data = com1_recv_data[com1_rx_udi];// ring   ε
			switch(com1_rx_data){
				case  '1' : exit_flg = 1; break;
				case  '2' :
					GpioDataRegs.GPADAT.all = 0x0000;
					Printf(_COM1,"OUT(GPIO0-15) : 0x0000\r\n");
					break;
				case  '3' :
					GpioDataRegs.GPADAT.all = 0xaaaa;
					Printf(_COM1,"OUT(GPIO0-15) : 0xaaaa\r\n");
					break;
				case  '4' :
					GpioDataRegs.GPADAT.all = 0x5555;
					Printf(_COM1,"OUT(GPIO0-15) : 0x5555\r\n");
					break;
				case  '5' :
					GpioDataRegs.GPADAT.all = 0xffff;
					Printf(_COM1,"OUT(GPIO0-15) : 0xffff\r\n");
					break;
		    	default   : break;
			}
	    }
	}
	com1_rx_usi = com1_rx_udi = 0;
}

// =========================== ANALOG TEST =========================
// [μ] void					    
// -----------------------------------------------------------------
void analog_test(void)
{
unsigned int adc_values[10];
unsigned char com1_rx_data;
int i,exit_flg = 0,datai;

	Printf(_COM1,"%s","============ ANALOG TEST ==========\r\n");
	Printf(_COM1,"%s","- 1 : RETURN POP UP               -\r\n");
	Printf(_COM1,"%s","- 2 : analog data read(CH0-7)     -\r\n");
	Printf(_COM1,"%s","-----------------------------------\r\n");
	com1_rx_usi = com1_rx_udi = 0;
	while(exit_flg == 0){
		if(com1_rx_usi != com1_rx_udi){
			com1_rx_usi = com1_rx_udi = 0;
			com1_rx_data = com1_recv_data[com1_rx_udi];// ring   ε
			switch(com1_rx_data){
				case  '1' : exit_flg = 1; break;
				case  '2' : 
					Adc_Read(adc_values);
					Printf(_COM1,"\r\n");
			 		for(i = 0; i < 8; i++){
			 			datai = adc_values[i];
						Printf(_COM1,"AD CH%d : %04d > %04x\r\n",i,datai,datai); 
				 	}
				 	break;
		    		default:
		    			break;
			}
	    }
	}
	com1_rx_usi = com1_rx_udi = 0;
}

// ========================= SRAM ׽Ʈ α׷ ==================
// [μ] void
// -----------------------------------------------------------------
void sram_test(void)
{
char ch,buff[50],buff1[50],buff2[50],buff3[50];
unsigned char com1_rx_data;
unsigned datau;
int i,j,cnt,exit_flg = 0;
long saddr,eaddr;

	Printf(_COM1,"%s","=========== SRAM TEST ============\r\n");
	Printf(_COM1,"%s","- 1 : RETURN POP UP               -\r\n");
	Printf(_COM1,"%s","- 2 : Read Data(00000-fffffh)     -\r\n");
	Printf(_COM1,"%s","- 3 : Write Data(00000-ffffh)     -\r\n");
	Printf(_COM1,"%s","-----------------------------------\r\n");

	com1_rx_usi = com1_rx_udi = 0;
	while(exit_flg == 0){
		if(com1_rx_usi != com1_rx_udi){
			com1_rx_usi = com1_rx_udi = 0;
			com1_rx_data = com1_recv_data[com1_rx_udi];// ring   ε
			switch(com1_rx_data){
			    case  '1' : exit_flg = 1; break;
			    case  '2' : i = j = cnt = 0;
					Printf(_COM1,"\r\nREAD(#####,#####) > ");
					rx_string(buff);
					ch = buff[i++];		//  ˻ ڷ 
					while(ch != 0x0){
			    			if((ch == ':') || (ch == ',') || (ch == ' ')){
							j = 0;
							cnt++;
				    		}
				    		else{
							if(cnt == 0){
					    			buff1[j++] = ch;
			    					buff1[j] = 0x0;
							}
							else if(cnt == 1){
					    			buff2[j++] = ch;
					    			buff2[j] = 0x0;
							}
						}
					    	ch = buff[i++];
					}
					if(cnt == 1){		// ˻ 
						saddr = atoh(buff1);//  ּ ȯ(HEX)
						eaddr = atoh(buff2);//  ּ ȯ(HEX)
						if(saddr <= eaddr){
							cnt = 0;
							Printf(_COM1,"%08lX > ",saddr);// ּ ǥ
							for( ; saddr <= eaddr; saddr++){
								datau = EX_SRAM_ADDR[saddr];//  
								Printf(_COM1,"%04X ",datau);// Ÿ ǥ
								cnt++;
								if(cnt == 13){// 1 ǥ
									cnt = 0;
									if(saddr+1 <= eaddr) Printf(_COM1,"\r\n%08lX > ",saddr+1);// ּ ǥ
								}
							}
							Printf(_COM1,"\r\n");
					    	}
					}
					break;
			    case  '3' : i = j = cnt = 0;
					Printf(_COM1,"\r\nWRITE(#####,#####,####) > ");
					rx_string(buff);
					ch = buff[i++];		//  ˻ ڷ 
					while(ch != 0x0){
						if((ch == ':') || (ch == ',') || (ch == ' ')){
							j = 0;
							cnt++;
					    	}
						else{
							if(cnt == 0){
								buff1[j++] = ch;
								buff1[j] = 0x0;
							}
							else if(cnt == 1){
								buff2[j++] = ch;
								buff2[j] = 0x0;
							}
							else if(cnt == 2){
								buff3[j++] = ch;
								buff3[j] = 0x0;
							}
						}
						ch = buff[i++];
					}
					if(cnt == 2){		// ˻ 
						saddr = atoh(buff1);//  ּ ȯ(HEX)
						eaddr = atoh(buff2);//  ּ ȯ(HEX)
						datau = (unsigned)atoh(buff3);//  ȯ(HEX)
						if(saddr <= eaddr){
							for( ; saddr <= eaddr; saddr++){
								EX_SRAM_ADDR[saddr] = datau;//  
							}
							Printf(_COM1,"SRAM Data Write OK !\r\n");
						}
					}
					break;
			    default   : break;
			}
		}
	}
	com1_rx_usi = com1_rx_udi = 0;
}

// ================== ASCII͸ HEXͷ ȯ ===============
// [μ] unsigned char buff[]					    
// Item1  ȯ  					    
// [] 0 - 7fffffffh 					    
// -----------------------------------------------------------------
long atoh(char buff[])
{
char ch;
int i = 0;
long data = 0;

	ch = buff[i++]; 						//  ε
	ch = toupper(ch);						// 빮 ȯ
	while(ch != 0){
	    ch = ch - '0';              				// 0 - 9 ȯ 
	    if(ch > 9) ch = ch - 7;					// A - F ȯ
	    if(ch < 0 || ch > 0x0f) ch = 0;				//  ˻
	    else ch = ch & 0x0f;
	    data = data << 4;						// ȯ  
	    data |= ch;
	    ch = buff[i++];						//  ε
	    ch = toupper(ch);						// 빮 ȯ 
	}
	return(data);
}

// ==================== κ ڿ  ================= 
// [μ] char buff[]					     
// Item1   Ÿ  (ִ 30)			     
// -----------------------------------------------------------------
void rx_string(char buff[])
{
char ch;
int exit_flg = 0,scnt = 0;

	buff[0] = 0x0;						//  ũ
	com1_rx_usi = com1_rx_udi = 0;
	while(exit_flg == 0){
		while(com1_rx_usi == com1_rx_udi);		//  
		ch = com1_recv_data[com1_rx_udi];		// ring   ε
		com1_rx_usi = com1_rx_udi = 0;
		ch = toupper(ch);				//  ȯ
		if(ch == 0x08){					// BSŰ м
			if(scnt == 0) com1_putch(0x07);		//  溸 ۽
			else{					// 1ڸ 
			    com1_putch(0x08);
			    com1_putch(' ');
			    com1_putch(0x08);
			    scnt--;
			}
		}
		else if(ch == 0x0d){
			exit_flg = 1;				// Ż  ON
			buff[scnt] = 0x0;
			Printf(_COM1,"\r\n");
		}
		else{
			buff[scnt++] = ch;			// ڷ 
			com1_putch(ch);
			if(scnt >= 30){ 			//   ʰ 
			    scnt = 29;
			    com1_putch(0x08);
			    com1_putch(0x07);
			}
		}
	}
}
